package com.tmax.openframe.service;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.OIVPUPDT;
import com.tmax.openframe.dto.OIVPUPDT_DFHCOMMAREADto;
import com.tmax.openframe.dto.OIVPUPDT_InputDto;
import com.tmax.openframe.dto.OIVPUPDT_OutputDto;
import com.tmax.openframe.util.*;
import com.tmax.proobject.core.ServiceObject;
import com.tmax.proobject.engine.logger.ServiceLogger;
import com.tmax.proobject.engine.servicemanager.ServiceManager;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.logger.ProObjectLogger;
import com.tmax.proobject.model.dataobject.DataObject;
import java.math.*;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @ServiceObject class OIVPUPDTService
        implements
        com.tmax.proobject.model.service.ServiceObject<OIVPUPDT_InputDto, OIVPUPDT_OutputDto> {
    private ProObjectLogger logger = ServiceLogger.getLogger();
    private OIVPUPDT_OutputDto output = new OIVPUPDT_OutputDto();

    public @Override OIVPUPDT_OutputDto service(OIVPUPDT_InputDto input)
            throws Throwable {
        OIVPUPDT program = new OIVPUPDT();
        PreProcessor preProcessor = new PreProcessor(input, output);
        preProcessor.executePreProcessing();
        program.setInputDto(input);
        program.setOutputDto((OIVPUPDT_OutputDto) preProcessor.getOutputDto());
        DBProcessing transPreProcessing = new TransPreProcessing();
        DataObject comArea = preProcessor.executeCommAreaSetting();
        if (comArea != null) {
            program.getContainer().setDFHCOMMAREA(
                    ((OIVPUPDT_DFHCOMMAREADto) comArea).getDFHCOMMAREA());
        }
        if (transPreProcessing.isStart(input.getSystemDto())) {
            if (transPreProcessing.isTrmRdy(input.getSystemDto())) {
                program.run();
                DBProcessing transPostProcessing = new TransPostProcessing();
                transPostProcessing.execute(input.getSystemDto());
            }
        } else {
            program.run();
        }
        if (program.isStart()) {
            WaitObject waitObject = program.getWaitObject();
            if (ServiceManager.getReply(waitObject, 60 * 1000) == null) {
            } else {
                waitObject.get();
            }
        }
        PostProcessor postProcessor = new PostProcessor(input, output);
        postProcessor.executePostProcessing();
        return output;
    }
}
